#!/usr/bin/env python
# coding: utf-8

# In[1]:


import csv
import xmltodict
import numpy as np
from os import listdir
from os.path import isfile, join
import cv2


# In[ ]:



class data:
    def __init__(self):
        self.file_name = 'name_string.csv'
        self.set_bag_of_words = {'made','the'}#initialize
        
    def extract_word(self, directory_path):
#         dir_1 = 'formsA-D'
#         dir_2 = 'formsE-H'
#         dir_3 = 'formsI-Z'
        
        list_of_pairs = []
        
        
        files = [f for f in listdir('xml') if isfile(join('xml', f))]
        for x in range(len(files)):
            with open('./xml/'+files[x], 'r') as f: 
                data = xmltodict.parse(f.read())

                for i in range(len(data['form']['handwritten-part']['line'])):
                    num = len(data['form']['handwritten-part']['line'][i]['word'])
                    for j in range(num):
                        try:
                            word = data['form']['handwritten-part']['line'][i]['word'][j]['@text']
                            #file name of word 
                            img_filename = data['form']['handwritten-part']['line'][i]['word'][j]['@id']
                        except:
                            word = data['form']['handwritten-part']['line'][i]['word']['@text']
                            #file name of word 
                            img_filename = data['form']['handwritten-part']['line'][i]['word']['@id']
                            
                                               
                        temp = img_filename.split('-')
                        path = 'words'+'/'+temp[0]+'/'+temp[0]+'-'+ temp[1]+'/'+img_filename+'.png'

#                         if ord(img_filename[0]) < ord('e'):
#                             path = dir_1 + '/' + img_filename + '.png'
#                         elif ord(img_filename[0]) < ord('i'):
#                             path = dir_2 + '/' + img_filename + '.png'
#                         else:
#                             path = dir_3 + '/' + img_filename + '.png'

                        list_of_pairs.append([path, word])
                        self.set_bag_of_words.add(word)

        with open(self.file_name,'w', newline='') as csvfile:
            writer = csv.writer(csvfile)
            writer.writerow(["image_path", "word"])
            for r in range(len(list_of_pairs)):
                writer.writerow(list_of_pairs[r])            


# In[ ]:


d1 = data()
d1.extract_word('trtr')


# In[ ]:


len(d1.set_bag_of_words)


# In[ ]:


with open('bag_of_words.txt', 'w') as f:
    for item in list(d1.set_bag_of_words):
        f.write("%s\n" % item)


# In[ ]:





# In[4]:


import cv2
with open('bag_of_words.txt', 'r') as f:
    data = f.read()


# In[5]:


d = data.split('\n')[:-2]


# In[ ]:





# In[ ]:


row[0]
with open(row[0], 'r') as file:
    a = file.read()


# In[6]:


with open('name_string.csv', 'r') as file:
    reader = csv.reader(file)
    for row in reader:
        print(row)


# In[9]:


bag_of_words = {'thus', 'a'}
with open('name_string.csv', 'r') as file:
    reader = csv.reader(file)
    for row in reader:        
        bag_of_words.add(row[1])


# In[10]:


bag = list(bag_of_wors)
with open('bag_of_words.txt', 'w') as f:
    for item in bag:
        f.write("%s\n" % item)


# In[ ]:





# In[45]:


import os
import shutil

root_path = 'dataset_classwise_0/'
folders = bag
for folder in folders:
    if folder != '/':
        try:
            n = len(os.listdir(root_path + folder))
            
            if n < 20:
                print(root_path + folder)
                shutil.rmtree(root_path +folder+'/')
            elif n > 20:
                r = n - 20
                for i in range(r):
                    pt = root_path +folder+'/'+os.listdir(root_path + "/" + folder)[i]
                    os.remove(pt)
                    print(n, pt)
        except:
            a = 10#print(folder)
            
                

    


# In[17]:


folders = bag
for folder in folders:
    pt = folder+'/'+os.listdir(root_path + "/" + folder)[0]
    print(pt)


# In[27]:


root_path = 'about.png'
print(root_path)
image = cv2.imread(root_path)
print(image)
cv2.imshow('image',image)


# In[29]:


import shutil, os

with open('name_string.csv', 'r') as file:
    reader = csv.reader(file)
    first_row = next(reader)
    for row in reader:
        if row[1] != '/':
            src = row[0]
            dst = 'dataset_classwise/' + row[1]+'/'
            shutil.copy(src, dst)


# In[8]:


# Save image in set directory 
# Read RGB image 

with open('name_string.csv', 'r') as file:
    reader = csv.reader(file)
    first_row = next(reader)
    for row in reader:
        try:            
            img = cv2.imread(row[0])  
#             print('/'+row[0])
            img_grey = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
            # Output img with window name as 'image' 
            r, c = img_grey.shape
            ratio = c/r
            new_row = 32
            new_col = c
            if r>32:
                new_col = c - int((r-32)*(ratio))
            if new_col > 128:
                new_col = 128
            resized = cv2.resize(img_grey, (new_col,new_row), interpolation = cv2.INTER_AREA)

            rw,cl = resized.shape

            image = cv2.copyMakeBorder(resized,0 , 0, 0, 128-cl, cv2.BORDER_CONSTANT, value = [255,255]) 

            #print(image.shape)
            filename = 'Words/'+row[0][6:]
            cv2.imwrite(filename, image) 
            #cv2.imshow('image', image)  
            # Maintain output window utill 
            # user presses a key 
            #cv2.waitKey(0)         

            # Destroying present windows on screen 
            #cv2.destroyAllWindows()
        except:
            print('error at', row)


# In[ ]:





# In[ ]:


## image thresholding
def image_threshold():
    with open('name_string.csv', 'r') as file:
    reader = csv.reader(file)
    for row in reader:
        img = cv2.imread(row[0])
        print('/'+row[0])

        # Output img with window name as 'image' 
        cv2.imshow('image', img)  

        # Maintain output window utill 
        # user presses a key 
        cv2.waitKey(0)         

        # Destroying present windows on screen 
        cv2.destroyAllWindows()  


# In[18]:


import os
root = os.listdir('by_class/')
mi = 99999
for i in range(len(root)):
    letter_dir = os.listdir('by_class/'+root[i])
    if mi > len(letter_dir):
        mi = len(letter_dir)
print(mi)


# In[19]:


root = os.listdir('by_class/')
print(root)
mi = 0
for i in range(len(root)):
    letter_dir = os.listdir('by_class/'+root[i])
    print(letter_dir)
    for j in range(len(letter_dir) - 1800):
        path = 'by_class/'+root[i] +'/'+letter_dir[j]
        os.remove(path)


# In[2]:


import cv2
import matplotlib.pyplot as plt
import matplotlib.image as mpimg
img1 = cv2.imread('1.png',cv2.IMREAD_GRAYSCALE)
img2 = cv2.imread('2.png',cv2.IMREAD_GRAYSCALE)
img3 = cv2.imread('3.png',cv2.IMREAD_GRAYSCALE)
img4 = cv2.imread('4.png',cv2.IMREAD_GRAYSCALE)
(thresh, im_bw1) = cv2.threshold(img1, 128, 255, cv2.THRESH_BINARY_INV | cv2.THRESH_OTSU)
(thresh, im_bw2) = cv2.threshold(img2, 128, 255, cv2.THRESH_BINARY_INV | cv2.THRESH_OTSU)
(thresh, im_bw3) = cv2.threshold(img3, 128, 255, cv2.THRESH_BINARY_INV | cv2.THRESH_OTSU)
(thresh, im_bw4) = cv2.threshold(img4, 128, 255, cv2.THRESH_BINARY_INV | cv2.THRESH_OTSU)


# In[3]:


imgplot = plt.imshow(im_bw2/255)


# In[ ]:





# In[4]:


#find average letter width
def segment_into_letters(img):
    im_bw2 = img/255
    histo = img.sum(axis=0)
    fig = plt.figure()
    ax = fig.add_axes([0,0,1,1])
    ax.bar(range(0,len(histo)),histo)
    plt.show()
    window = np.ones(4)
    sc = []
    #convolution
    for i in range(len(histo)-len(window)):
        summation = 0
        for j in range(len(window)):
            summation += histo[i+j]*window[j]
        if summation == 0:#if noisy then adjust accordingly
            sc.append(i+1)
    
    return(sc)


# In[5]:


new_histo = segment_into_letters(im_bw2)
fig = plt.figure()
ax = fig.add_axes([0,0,1,1])
ax.bar(range(0,len(new_histo)),new_histo)
plt.show()


# In[6]:


#finding diffrentiation with sobel in x
def diffrentiate(X):
    #CONVLOVE WITH DIIFRENTIAL OPERATOR
    d = [-1, 0, 1]

    pos_of_highest_change = []
    for i in range(len(X) - 3):
        summation = 0
        for j in range(len(d)):
            summation += X[i+j]*d[j]
        if summation > 2:
            pos_of_highest_change.append(X[i])
    print(X[i-1])
    pos_of_highest_change.append(pos_of_highest_change[-1]+1)
    pos_of_highest_change.append(X[-1])
    return(pos_of_highest_change)


# In[7]:


pixel = diffrentiate(new_histo)
fig = plt.figure()
ax = fig.add_axes([0,0,1,1])
ax.bar(range(0,len(pixel)),pixel)
plt.show()
pixel


# In[8]:


imgplot = plt.imshow(im_bw2/255)
new_histo


# In[10]:


letter = im_bw2/255
i = 0
list_of_letters = []
while(i<len(pixel)-1):
    imgplot = plt.imshow(letter[:,pixel[i]:pixel[i+1]])
    list_of_letters.append(letter[:,pixel[i]:pixel[i+1]])
    print(pixel[i],pixel[i+1])
    plt.show()
    i = i+2


# In[84]:


#crop resize and border charachter
def char_preprocess(img):
    #find vertical projection
    vertical_projection = np.sum(img,axis=1)
    
    #find first and last non zeros projection
    left_index = 0
    right_index = 0
    for i in range(len(vertical_projection)):
        if (vertical_projection[i] != 0):
            left_index = i - 1
            break
    for j in range(len(vertical_projection)-1,0,-1):
        if (vertical_projection[j] != 0):
            right_index = j + 1
            break

    #crop image
    img_cropped = img[left_index: right_index,:]
    
    #resize image
    img_cropped_resized = cv2.resize(img_cropped, (int(img_cropped.shape[1]*.7), int(img_cropped.shape[0]*.7)), interpolation = cv2.INTER_AREA)
    imgplot = plt.imshow(img_cropped_resized)
    plt.show()
    #fill boder
    h = img_cropped_resized.shape[0]
    w = img_cropped_resized.shape[1]    
    thickness_h = int((64-h)/2)
    thickness_w = int((64-w)/2)
    print(thickness_h,thickness_w,h,w)
    normalized_img = cv2.copyMakeBorder(img_cropped_resized, thickness_h, thickness_h, thickness_w,thickness_w, cv2.BORDER_CONSTANT, value = [0,0])
    
    return(normalized_img)


# In[94]:



image_normalized = char_preprocess(list_of_letters[2])


# In[95]:


imgplot = plt.imshow(image_normalized)
plt.show()


# In[93]:


imgplot = plt.imshow(cv2.resize(list_of_letters[2], (64,64), interpolation = cv2.INTER_AREA))
plt.show()


# In[103]:


# import os
# classes = os.listdir('by_class/')
# char = ['A', 'Q','u','i','c','k','B','r','o','w','n','F','o','x','J','u','m','p','s','O','v','e','r','T','h','e','L','a','z','y','D','o','g']
# l = []
# for each_char in char:
#     list_of_char = os.listdir('by_class/'+each_char+'/')
#     img = plt.imread('by_class/'+each_char+'/'+list_of_char[50],)
#     l.append(img)
#     r = plt.imshow(img)
#     plt.show()


# In[104]:





# In[121]:


# stich = np.zeros([128,1,3])
# print(l[1].shape)
# for i in range(33):
#     stich = np.append(stich,l[i],axis=1)
# stich.shape


# In[123]:


# plt.imshow(stich)
# plt.savefig('stich.png')


# In[ ]:




